import { ERRORENUM } from "../../config/errorEnum";
import { modelMap } from "../../model/modelBind";
import { BizError } from "../../util/bizError";


/**
 * 查询单个数据
 * @param tableModel 表对象
 * @param param 
 * @returns 
 */
export async function selectOneDataByParam(tableModel, param:object) {
    let data = tableModel.findOne({where:param});
    return {data};
}


/**
 * 查询多个数据
 * @param tableName 表对象
 * @param param 
 * @returns 
 */
export async function selectDataListByParam(tableModel, param:any) {
    let data = tableModel.findAll({where:param});
    return {data};
}


/**
 * 分页查询
 * @param tableModel 
 * @param param 
 * @param pageNumber 
 * @param pageSize 
 * @returns 
 */
export async function selectDataListToPageByParam(tableModel, param:any, pageNumber:number, pageSize:number) {
    pageSize = pageSize || 10;
    let data = tableModel.findAll({where:param, offset:(pageNumber-1)*10, limit:pageSize});
    return {data};
}

export async function selectDataCountByParam(tableModel, param:any) {
    let data = tableModel.count({where:param});
    return {data};
}


export async function associationSelect(tableName:string, param:any) {
    let model = modelMap[tableName];
    if (!model) throw new BizError(ERRORENUM.不存在表);

    let data = await model.aggragateData(param);

    return {data};
}